package nl.rubend.zwemmen

import io.ktor.client.*
import io.ktor.client.call.*
import io.ktor.client.engine.cio.*
import io.ktor.client.request.*
import io.ktor.client.statement.*
import kotlinx.coroutines.runBlocking

//Copied from my WifiLogin app.
class CustomHttp {
    val httpClient = HttpClient(httpEngine) {
//        install(HttpCookies) {
//            storage=CustomCookieStorage()
//        }
    }
    fun get(url: String)= runBlocking { httpClient.get(url) }
    fun post(url: String, data: CustomRequestBody?=null)=runBlocking {
        if(data==null) httpClient.post(url)
        else httpClient.post(url) {
            headers {
                append("Content-Type", data.contentType)
            }
            setBody(data.data)
        }
    }
}
data class CustomRequestBody(
    val contentType: String,
    val data: String,
)
fun HttpResponse.text(): String {
    val this2=this
    return runBlocking {
        this2.body() as String
    }
}
fun HttpResponse.only200()=if(this.status.value==200) this else throw RuntimeException("status wasn't 200!")
fun String.toRequestBody(contentType: String="")=CustomRequestBody(contentType, this)

val httpEngine = CIO