package nl.rubend.zwemmen.providers.last

import com.google.gson.Gson
import com.google.gson.reflect.TypeToken
import nl.rubend.zwemmen.providers.DataProvider
import java.lang.reflect.Type

class LastProvider : DataProvider() {
    override val url = "https://swimtimes.rubend.nl/last"
    override fun getData(json: String): Map<String, Any> {
        val listType: Type = object : TypeToken<Map<String, List<Afstand>>>() {}.type
        return Gson()
            .fromJson<Map<String, List<Afstand>>>(json, listType)
            .map { (key,value)->key to value
                .groupBy {"${it.distance}m ${it.slag}: ${it.total}"}
                .map { (key,value)->key to value[0].let {
                    val list= mutableListOf(
                        "distance: ${it.distance}",
                        "total: ${it.total}",
                        "slag: ${it.slag}",
                        "tussentijden (berekend):",
                    )
                    list.addAll(it.subtimes.map { subtime -> "${subtime.distance}m: ${subtime.time}" })
                    list
                } }.toMap()
            }.toMap()
    }
}