package nl.rubend.zwemmen.providers.records

import com.google.gson.Gson
import com.google.gson.reflect.TypeToken
import nl.rubend.zwemmen.providers.DataProvider
import java.lang.reflect.Type

class RecordProvider : DataProvider() {
    override val url = "https://swimtimes.rubend.nl/records"
    override fun getData(json: String): Map<String, Any> {
        val listType: Type = object : TypeToken<List<Record>>() {}.type
        return Gson()
            .fromJson<List<Record>>(json ,listType)
            .groupBy { it.totaalAfstand }
            .map { (key,value)->key to value
                .groupBy { it.meters }
                .map { (key,value)->key to value[0].let {
                    val list= mutableListOf(
                        "afstand: ${it.afstand}",
                        "meters: ${it.meters}",
                        "tijd: ${it.tijd}",
                        "niveau: ${it.niveau}",
                        "datum: ${it.datum}",
                        "stad: ${it.stad}",
                        "totaalAfstand: ${it.totaalAfstand}",
                        "tussentijden(berekend):",
                    )
                    list.addAll(it.tussentijden.map { tussentijd -> "${tussentijd.distance}m: ${tussentijd.time}" })
                    list
                } }.toMap()
            }.toMap()
    }
}